-- credits to:
-- HopeASD (NGA qfeizaijun)/ 简繁(NGA zhangzhanxian3)
local addonName, addon = ...
addon[1] = {} -- Gloable
addon[2] = {} -- Function
addon[3] = {} -- Config
addon[4] = {} -- Locale

local G, F, C, L = unpack(addon)

local events = {}

local host = CreateFrame("Frame")
host:SetScript("OnEvent", function(_, event, ...)
	for func in pairs(events[event]) do
		if event == "COMBAT_LOG_EVENT_UNFILTERED" then
			func(event, CombatLogGetCurrentEventInfo())
		else
			func(event, ...)
		end
	end
end)

function G:RegisterEvent(event, func, unit1, unit2)
	if not events[event] then
		events[event] = {}
		if unit1 then
			host:RegisterUnitEvent(event, unit1, unit2)
		else
			host:RegisterEvent(event)
		end
	end

	events[event][func] = true
end

function G:UnregisterEvent(event, func)
	local funcs = events[event]
	if funcs and funcs[func] then
		funcs[func] = nil

		if not next(funcs) then
			events[event] = nil
			host:UnregisterEvent(event)
		end
	end
end

local DefaultDB = {
	FirstUSE = true;
	cvar = true,
	dbm = true,
	exrt = true,
	skada = true,
	tiny = true,
	mapicon = true,
	ui = true,
	chat = true,
	target = true,
	comb = true,
	syd = true,
	icon = true,
	plate = true,
	arrow = true,
	name = true,
	ct = true,
	unitf = true,
	cast = true,
	chatg = true,
	quest = true,
	smap = true,
	mmb = true,
	chatcopy = true,
	chatm = true,
	chatb = true,
	zu = true,
	stop = true,
	mh = true,
	sf = true,
	sq = false,
	debuff = false,
	ptexture = false,
	rtexture =false,
	class = false,
	autoquest = false,
	bc = true,
	ftip = 1,
	
}

local eventframe = CreateFrame("Frame")
eventframe:RegisterEvent("ADDON_LOADED")
eventframe:SetScript("OnEvent",function(self,_,addon)
	--if addon ~= "Inked" then return end
	if not InkedDB then InkedDB = {} end
	
		for i, j in pairs(DefaultDB) do
		if type(j) == "table" then
			if InkedDB[i] == nil then InkedDB[i] = {} end
			for k, v in pairs(j) do
				if InkedDB[i][k] == nil then
					InkedDB[i][k] = v
				end
			end
		else
			if InkedDB[i] == nil then InkedDB[i] = j end
		end
	end
	self:UnregisterAllEvents()

end)
local function TestFunc()
if InkedDB["ceshi"] ==  true  then print("InkedUi") end
end
G:RegisterEvent("PLAYER_LOGIN",TestFunc)



